"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DBRecordsArrayInstance = exports.DBRecordInstance = exports.DBRecordDraft = exports.DBRecordsBatchDraft = void 0;
const rest_api_proxy_js_1 = require("../api/rest-api-proxy.js");
class DBRecordsBatchDraft {
    constructor({ label, options = {
        returnResult: true,
        suggestTypes: true
    }, payload }) {
        this.label = label;
        this.options = options;
        this.payload = payload;
    }
    toJson() {
        return {
            label: this.label,
            options: this.options,
            payload: this.payload
        };
    }
}
exports.DBRecordsBatchDraft = DBRecordsBatchDraft;
class DBRecordDraft {
    constructor({ label, properties = [] }) {
        this.label = label;
        this.properties = properties;
    }
    toJson() {
        return {
            label: this.label,
            properties: this.properties
        };
    }
}
exports.DBRecordDraft = DBRecordDraft;
class DBRecordInstance extends rest_api_proxy_js_1.RestApiProxy {
    constructor(data, searchParams) {
        super();
        this.data = data;
        this.searchParams = searchParams;
    }
    async delete(transaction) {
        if (this.data) {
            return await this.apiProxy.records.deleteById(this.data.__id, transaction);
        }
    }
    async update(partialData, transaction) {
        if (this.data) {
            return this.apiProxy.records.update(this.data.__id, partialData, transaction);
        }
    }
    async set(data, transaction) {
        if (this.data) {
            return this.apiProxy.records.set(this.data.__id, data, transaction);
        }
    }
    async attach(target, options, transaction) {
        if (this.data) {
            return this.apiProxy.records.attach(this.data.__id, target, options, transaction);
        }
    }
    async detach(target, options, transaction) {
        if (this.data) {
            return this.apiProxy.records.detach(this.data.__id, target, options, transaction);
        }
    }
}
exports.DBRecordInstance = DBRecordInstance;
class DBRecordsArrayInstance extends rest_api_proxy_js_1.RestApiProxy {
    constructor(data, total, searchParams) {
        super();
        this.data = data;
        this.total = total;
        this.searchParams = searchParams;
    }
}
exports.DBRecordsArrayInstance = DBRecordsArrayInstance;
