import * as http_ from 'http';
import * as https_ from 'https';
import type { HttpClientResponseInterface, MakeRequestConfig } from './HttpClient.js';
import { HttpClient, HttpClientGenericResponse } from './HttpClient.js';
export declare class NodeHttpClient extends HttpClient {
    _agent?: http_.Agent | https_.Agent | undefined;
    constructor(agent?: http_.Agent | https_.Agent);
    makeRequest(urlString: string, { headers, method, protocol, requestData, timeout }: MakeRequestConfig): Promise<HttpClientResponseInterface>;
}
export declare class NodeHttpClientResponse extends HttpClientGenericResponse implements HttpClientResponseInterface {
    _res: http_.IncomingMessage;
    constructor(res: http_.IncomingMessage);
    getRawResponse(): http_.IncomingMessage;
    toStream(streamCompleteCallback: () => void): http_.IncomingMessage;
    toJSON(): any;
}
